>From 3992cc048a16e8eccce24ac038f9391ed5d78e71 Mon Sep 17 00:00:00 2001
From: Dimitar Zhekov <dimitar.zhekov@gmail.com>
Date: Wed, 27 Feb 2013 21:04:58 +0200
Subject: [PATCH] Check signal id in plugin_signal_connect() before adding it
 to the list of signals to disconnect on plugin unload.

---
 src/pluginutils.c |   13 ++++++++-----
 1 file changed, 8 insertions(+), 5 deletions(-)

diff --git a/src/pluginutils.c b/src/pluginutils.c
index 0c26ab1..e404155 100644
--- a/src/pluginutils.c
+++ b/src/pluginutils.c
@@ -118,12 +118,15 @@ void plugin_signal_connect(GeanyPlugin *plugin,
 		g_signal_connect_after(object, signal_name, callback, user_data) :
 		g_signal_connect(object, signal_name, callback, user_data);
 
-	if (!plugin->priv->signal_ids)
-		plugin->priv->signal_ids = g_array_new(FALSE, FALSE, sizeof(SignalConnection));
+	if (id > 0)
+	{
+		if (!plugin->priv->signal_ids)
+			plugin->priv->signal_ids = g_array_new(FALSE, FALSE, sizeof(SignalConnection));
 
-	sc.object = object;
-	sc.handler_id = id;
-	g_array_append_val(plugin->priv->signal_ids, sc);
+		sc.object = object;
+		sc.handler_id = id;
+		g_array_append_val(plugin->priv->signal_ids, sc);
+	}
 }
 
 
-- 
1.7.10.4

